Bash函数中的返回语句和退出语句在退出代码方面有什么区别?
当前回答
首先,return是一个关键字,exit是一个函数。
也就是说,这里有一个最简单的解释。
返回
它从函数中返回一个值。
exit
它退出或放弃当前shell。
其他回答
Return将导致当前函数超出作用域,而exit将导致脚本在调用它的地方结束。下面是一个示例程序来帮助解释这一点:
#!/bin/bash
retfunc()
{
echo "this is retfunc()"
return 1
}
exitfunc()
{
echo "this is exitfunc()"
exit 1
}
retfunc
echo "We are still here"
exitfunc
echo "We will never see this"
输出
$ ./test.sh
this is retfunc()
We are still here
this is exitfunc()
简单来说(主要针对编程新手),我们可以说:
`return`: exits the function,
`exit()`: exits the program (called as process while running)
如果你观察一下,这是非常基本的,但是…
`return`: is the keyword
`exit()`: is the function
在其他一些答案中添加一个可操作的方面:
两者都可以给出退出代码- default或由函数定义,并且唯一的“default”是零,表示成功退出和返回。任何状态都可以有一个自定义数字0-255,包括成功。
返回通常用于运行在当前shell中的交互式脚本,称为with。例如Script.sh,它只是将您返回到调用shell。然后,调用shell可以访问返回代码- $?给出定义的返回状态。 在这种情况下,Exit还会关闭shell(包括SSH连接,如果这是您的工作方式的话)。
如果脚本是可执行的,并且从另一个脚本或shell调用并且在子shell中运行,那么Exit是必要的。然后退出码可以被调用shell访问-在这种情况下return会给出一个错误。
Exit终止当前进程;不管有没有退出码,都应该把它看作一个系统,而不是一个程序函数。注意,当使用源时,exit将结束shell。但是,在运行时,它将退出脚本。 从函数返回,返回到调用后的指令,带或不带返回码。Return是可选的,在函数末尾是隐式的。Return只能在函数内部使用。
我想补充一点,在获取源代码的同时,不杀死shell而从函数中退出脚本并不容易。我认为,“测试”脚本上的示例更好:
#!/bin/bash
function die(){
echo ${1:=Something terrible wrong happen}
#... clean your trash
exit 1
}
[ -f /whatever/ ] || die "whatever is not available"
# Now we can proceed
echo "continue"
做以下事情:
user$ ./test
Whatever is not available
user$
测试后,外壳会闭合。
user$ . ./test
Whatever is not available
只有测试将完成,并显示提示。
解决方案是将潜在的过程包含在(和)中:
#!/bin/bash
function die(){
echo $(1:=Something terrible wrong happen)
#... Clean your trash
exit 1
}
( # Added
[ -f /whatever/ ] || die "whatever is not available"
# Now we can proceed
echo "continue"
) # Added
现在,在这两种情况下,只有test将退出。
如果将Bash脚本转换为函数,则通常将退出N替换为返回N。调用该函数的代码将把返回值视为子进程的退出代码。
在函数中使用exit将强制整个脚本结束。